CEL: Crystal Entity Layer: iPcBillboard Struct Reference (CEL: Crystal Entity Layer Public API Reference)

| ## Public API Reference

- Main Page
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# iPcBillboard Struct Reference

Billboard property class. More...

`#include <propclass/billboard.h>`

List of all members.

## Public Member Functions
virtual bool | AreEventsEnabled () const =0
| Return true if events are enabled.
virtual void | EnableEvents (bool e)=0
| Enable or disable listening for events for this billboard.
virtual iBillboard * | GetBillboard ()=0
| Get the billboard.
virtual const char * | GetBillboardName ()=0
| Get the name of the billboard.
virtual void | SetBillboardName (const char *name)=0
| Set the name of the billboard.

## Detailed Description

Billboard property class.

This property class can send out the following messages to the behaviour (add prefix 'cel.parameter.' to get the ID for parameters):

- pcbillboard_select: billboard is selected (x,y,button)
- pcbillboard_move: mouse moves over billboard (x,y,button)
- pcbillboard_moveaway: mouse moves away from billboard (x,y,button)
- pcbillboard_unselect: billboard is unselected (x,y,button)
- pcbillboard_doubleclick: billboard is double clicked (x,y,button)

This property class supports the following actions (add prefix 'cel.action.' to get the ID of the action and add prefix 'cel.parameter.' to get the ID of the parameter):

- DrawMesh: parameters 'materialname' (string), 'factory' (string), optional: 'distance' (float), optional: 'rotate' (vector3), optional: 'angle' (float).

This property class supports the following properties (add prefix 'cel.property.' to get the ID of the property:

- name (string, read/write): name of the billboard.
- materialname (string, read/write): name of the material. Warning! It is important to make sure the materials using the billboard have the <keepimage> flag set!
- materialnamefast (string, read/write): name of the material (faster way to set).
- clickable (bool, read/write): clickable (default no).
- movable (bool, read/write): movable (default no).
- visible (bool, read/write): visible (default yes).
- restack (bool, read/write): restackable on selection (default no).
- sendmove (bool, read/write): send move/moveaway events (default no).
- color (color, read/write): color of this billboard.
- width (long, read/write): width of this billboard.
- height (long, read/write): height of this billboard.
- widthpct (float, read/write): width of this billboard in percentage.
- heightpct (float, read/write): height of this billboard in percentage.
- x (long, read/write): x position of this billboard.
- y (long, read/write): y position of this billboard.
- uv_topleft (vector2, read/write): topleft uv coordinate in material.
- uv_botright (vector2, read/write): botright uv coordinate in material.
- layer (string, read/write): layer name.
- text (string, read/write): optional text on billboard.
- text_offset (vector2, write): offset for text in billboard space.
- text_fg_color (color, write): foreground color.
- text_bg_color (color, write): background color.
- text_font_size (float, write): font size. Set this before setting text_font. Otherwise default is 10.
- text_font (string, write): font.
- text_default_fg_color (color, write): default foreground color (for all billboards).
- text_default_bg_color (color, write): default background color (for all billboards).
- text_default_font_size (float, write): font size. Set this before setting text_default_font. Otherwise default is 10.
- text_default_font (string, write): default font (for all billboards).

Definition at line 91 of file billboard.h.

## Member Function Documentation

virtual bool iPcBillboard::AreEventsEnabled | ( |  | ) | const`[pure virtual]`

Return true if events are enabled.

virtual void iPcBillboard::EnableEvents | ( | bool | e | ) | `[pure virtual]`

Enable or disable listening for events for this billboard.

virtual iBillboard* iPcBillboard::GetBillboard | ( |  | ) | `[pure virtual]`

Get the billboard.

virtual const char* iPcBillboard::GetBillboardName | ( |  | ) | `[pure virtual]`

Get the name of the billboard.

virtual void iPcBillboard::SetBillboardName | ( | const char * | name | ) | `[pure virtual]`

Set the name of the billboard.

The documentation for this struct was generated from the following file:

- propclass/billboard.h